1. 程式人生 > >hdu-2141(二分查找+暴力)

hdu-2141(二分查找+暴力)

輸出 -c stream 否則 ++ script nbsp 判斷 bin

Description
Give you three sequences of numbers A, B, C, then we give you a number X. Now you need to calculate if you can find the three numbers Ai, Bj, Ck, which satisfy the formula Ai+Bj+Ck = X.

Input
There are many cases. Every data case is described as followed: In the first line there are three integers L, N, M, in the second line there are L integers represent the sequence A, in the third line there are N integers represent the sequences B, in the forth line there are M integers represent the sequence C. In the fifth line there is an integer S represents there are S integers X to be calculated. 1<=L, N, M<=500, 1<=S<=1000. all the integers are 32-integers.

Output
For each case, firstly you have to print the case number as the form “Case d:”, then for the S queries, you calculate if the formula can be satisfied or not. If satisfied, you print “YES”, otherwise print “NO”.

Sample Input
3 3 3
1 2 3
1 2 3
1 2 3
3


1
4
10

Sample Output
Case 1:
NO
YES
NO

題目大意
給A,B,C三個序列,分別從這三個序列中找三個數,若存在三個數之和等於X,則輸出”YES”,否則輸出”NO”

解析
三重循環的搜索肯定是不能用的。我的解法是將a+b的值存到ab數組中,將該數組排序。再用二分搜索判斷x-c是否存在於該數組中,若存在,則證明存在x=a+b+c,輸出’YES’即可。若對於所有c,都不存在x-c屬於該數組,則證明不存在x=a+b+c,輸出’NO’即可。存在一定的技巧,下面貼一波代碼

代碼

#include <iostream>
#include<cstdio>
#include<algorithm>

using namespace std;

int main()
{
    int a[510],b[510],c[510],ab[250010];
    int l,n,m;
    int s;
    int x[1010];
    int kase=0;
    bool ans;
    while(scanf("%d%d%d",&l,&n,&m)!=EOF){
        kase++;
        for(int i=0;i<l;i++){
            scanf("%d",&a[i]);
        }
        for(int i=0;i<n;i++){
            scanf("%d",&b[i]);
        }
        for(int i=0;i<m;i++){
            scanf("%d",&c[i]);
        }
        scanf("%d",&s);
        for(int i=0;i<s;i++){
            scanf("%d",&x[i]);
        }
        for(int i=0;i<l;i++){
            for(int j=0;j<n;j++){
                ab[i*l+j]=a[i]+b[j];
            }
        }
        sort(ab,ab+l*n);
        printf("Case %d:\n",kase);
        for(int i=0;i<s;i++){
            ans=false;
            for(int j=0;j<m;j++){
                if(binary_search(ab,ab+l*n,x[i]-c[j])){
                    ans=true;
                    break;
                }
            }
            if(ans){
                printf("YES\n");
            }else{
                printf("NO\n");
            }
        }
    }

}

hdu-2141(二分查找+暴力)